/*
 * Created by SharpDevelop.
 * User: Okano
 * Date: 2007/12/04
 * Time: 11:56
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Text;

namespace luapath
{
	/// <summary>
	/// CtH[
	/// </summary>
	public partial class MainForm : Form
	{
		bool modified = false;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
			
            // [U[ϐ擾
			string env = Environment.GetEnvironmentVariable("LUA_PATH", EnvironmentVariableTarget.User);
			
			if(env != null)
				foreach(string s in env.Split(';'))
                    pathList.Items.Add(new PathData(s));
			
			disableButtons();
		}
		
		void PathListSelectedIndexChanged(object sender, EventArgs e)
		{
			int index = pathList.SelectedIndex;
			if(index != -1){
				enableButtons();
				if(index == 0)
					upButton.Enabled = false;
				if(index == pathList.Items.Count - 1)
					downButton.Enabled = false;
				
			}
			else{
				disableButtons();
			}
		}
		
        /// <summary>
        /// ҏWȂǂ̃{^Lɂ
        /// </summary>
 		void enableButtons(){
			editButton.Enabled = removeButton.Enabled = upButton.Enabled = downButton.Enabled = true;
			this.AcceptButton = editButton;
		}
		
        /// <summary>
        /// ҏWȂǂ̃{^𖳌ɂ
        /// </summary>
		void disableButtons(){
			editButton.Enabled = removeButton.Enabled = upButton.Enabled = downButton.Enabled = false;
			this.AcceptButton = appendButton;
		}
		
		
		void AppendButtonClick(object sender, EventArgs e)
		{
			PathData ret = EditDialog.Show(this, null);
			if(ret != null){
				pathList.Items.Add(ret);
				modified = true;
			}
		}
		
		void MainFormFormClosing(object sender, FormClosingEventArgs e)
		{
			if(modified){
				switch(MessageBox.Show("ύXKp܂H", "luapath", MessageBoxButtons.YesNoCancel)){
					case DialogResult.Yes:
						StringBuilder env = new StringBuilder();

                        // ϐ𐶐
						foreach(object i in pathList.Items){
							env.Append(';');
							env.Append((i as PathData).CompletePath);
						}

                        // ݒ
						Environment.SetEnvironmentVariable("LUA_PATH", env.ToString(1, env.Length - 1), EnvironmentVariableTarget.User);
						break;
					case DialogResult.Cancel:
						e.Cancel = true;
						break;
				}
			}
		}
		
		void EditButtonClick(object sender, EventArgs e)
		{
			PathData oldPath = pathList.SelectedItem as PathData;
			PathData ret = EditDialog.Show(this, oldPath);
			if(ret != null){
				pathList.Items.Insert(pathList.SelectedIndex, ret);
				pathList.Items.Remove(oldPath);
				modified = true;
			}
		}
		
		void CloseButtonClick(object sender, EventArgs e)
		{
			this.Close();
		}
		
		void RemoveButtonClick(object sender, EventArgs e)
		{
			string pathtext = pathList.Text;
			if(MessageBox.Show("ȉ̃pX폜Ă낵łH\n" + pathtext, "luapath", MessageBoxButtons.YesNo) == DialogResult.Yes){
				pathList.Items.Remove(pathList.SelectedItem);
				modified = true;
			}
			
		}
		
		void UpButtonClick(object sender, EventArgs e)
		{
			int index = pathList.SelectedIndex;
			object obj = pathList.SelectedItem;
			
			pathList.SuspendLayout();
			
			pathList.Items.Remove(obj);
			pathList.Items.Insert(index - 1, obj);
			pathList.SelectedIndex = index - 1;
			
			pathList.ResumeLayout();
			modified = true;
		}
		
		void DownButtonClick(object sender, EventArgs e)
		{
			int index = pathList.SelectedIndex;
			object obj = pathList.SelectedItem;
			
			pathList.SuspendLayout();
			
			pathList.Items.Remove(obj);
			pathList.Items.Insert(index + 1, obj);
			pathList.SelectedIndex = index + 1;
			
			pathList.ResumeLayout();
			modified = true;
		}
	}
	
	/// <summary>
	/// pXf[^NX
	/// </summary>
	public class PathData {
        string dir;     // fBNg
		string suffix;  // gq
		
		public string Directory{
			get{return dir;}
			set{dir=value;}
		}
		
		public string Suffix{
			get{return suffix;}
			set{suffix=value;}
		}
		
        /// <summary>
        /// ftHgRXgN^
        /// ݂̃fBNgƁA".lua"gqݒ肳
        /// </summary>
		public PathData(){
			dir = System.Environment.CurrentDirectory;
			suffix = ".lua";
		}
		
        /// <summary>
        /// Rs[RXgN^
        /// </summary>
        /// <param name="from">Rs[PathData</param>
		public PathData(PathData from){
			dir = from.dir;
			suffix = from.suffix;
		}
		
        /// <summary>
        /// RXgN^
        /// fBNgƊgqݒ肷
        /// </summary>
        /// <param name="_dir">fBNg</param>
        /// <param name="_suf">gq(hbgȍ~)</param>
		public PathData(string _dir, string _suf){
			dir = _dir.Replace('/', '\\');
			suffix = _suf;
		}
		
        /// <summary>
        /// LUA_PATHvfƂRXgN^
        /// </summary>
        /// <param name="path">LUA_PATH̕(: C:/games/RC15B26/?.lua)</param>
		public PathData(string path){
			string[] pp = path.Split('?');
			
			switch(pp.Length){
				case 0:
					dir = ".\\";
					suffix = "lua";
					break;
				case 1:
					dir = pp[0].Replace('/', '\\');
					suffix = "";
					break;
				default:
					dir = pp[0].Replace('/', '\\');
					suffix = pp[1];
					break;
			}
		}
		
        /// <summary>
        /// LUA_PATHԂ
        /// </summary>
        /// <returns>LUA_PATH</returns>
		public override string ToString()
		{
			if(dir.EndsWith("\\"))
				return dir.Replace('\\', '/') + "?" + suffix;
			else
				return dir.Replace('\\', '/') + "/?" + suffix;
		}
		
        /// <summary>
        /// (ListBoxp)LUA_PATHԂ
        /// </summary>
		public string CompletePath{
			get{return this.ToString();}
		}
	}
	

}
